SystemOrganization addCategory: #'GT-Tools'!

Object subclass: #GTProfStefNoView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
close! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
open
! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:05'!
showLesson: aLesson
	^ aLesson lesson! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
showLesson: aLesson withTitle: aString
	^ aLesson! !

GLMGlobalBrowserTemplate subclass: #GTClassicCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTClassicCodeBrowser commentStamp: 'tg 12/29/2009 04:03' prior: 0!
self openOn: Smalltalk organization categories.!

!GTClassicCodeBrowser methodsFor: 'as yet unclassified' stamp: 'tg 1/20/2010 10:53'!
buildBrowser
	| lintBrowser |
	browser := GLMTabulator new.
	browser
		row: #navigation;
		row: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: GTClassicCodeNavigator new browser ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: 'Method source';
				display: [ :class :method | class sourceCodeAt: method ];
				forSmalltalk: [ :class | class ].
			browser text
				forSmalltalk;
				useExplicitNotNil;
				title: 'Class definition';
				display: [ :class | class definition ];
				when: [:class | class notNil].
			browser text
				title: 'Class comment';
				display: [ :class | class comment ];
				useExplicitNotNil;
				when: [:class | class notNil].
			lintBrowser := GTLintBrowser new browser.
			lintBrowser allowNil; when: [:clas :mth | clas notNil ].
			browser custom: lintBrowser
		].
	"for updating selection through lintBrowser"
	"browser sendTo: #navigator->#faultyMethod from: #source->#faultyMethod."
	^ browser! !

GLMGlobalBrowserTemplate subclass: #GTClassicCodeNavigator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTClassicCodeNavigator commentStamp: 'tg 12/29/2009 04:04' prior: 0!
self openOn: Smalltalk organization categories.!

!GTClassicCodeNavigator methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:04'!
buildBrowser
	browser := GLMTabulator new.
	browser
		column: #classCats;
		column: #classes;
		column: #categories;
		column: #methods.
	browser
		showOn: #classCats;
		using: 
			[ browser list ].
	browser
		showOn: #classes;
		from: #classCats;
		using: [
			browser tree
				display: [ :classCat | 
					(Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
				children: [ :each | each traitComposition traits ];
				title: 'Class list'.
			browser mondrian 
				painting: [ :view :package |
					view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [:name | Smalltalk classNamed: name]).
					view edgesFrom: #superclass.
					view treeLayout.];
				title: 'Hierarchy'.
 ].
	browser
		showOn: #categories;
		from: #classes;
		using: [ browser list display: [ :class | class organization categories ] ].
	browser
		showOn: #methods;
		from: #classes;
		from: #categories;
		using: 
			[ browser list
				display: 
					[ :class :category | 
					(class organization listAtCategoryNamed: category) asSortedCollection].
			browser list
				useExplicitNotNil;
				when: [ :class :category | class notNil and: [ category isNil ] ];
				display: [ :class :category | class selectors asSortedCollection ] ].
	browser 
		sendToOutside: #selectedClassCategory
		from: #classCats.
	browser 
		sendToOutside: #selectedClass
		from: #classes.
	browser 
		sendToOutside: #selectedMethod
		from: #methods.
	"for updating selection from lintBrowser"
	"browser 
		sendTo: #methods -> #selection
		fromOutside: #faultyMethod."
	^ browser! !

GLMGlobalBrowserTemplate subclass: #GTCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTCodeBrowser commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTCodeBrowser classSide methodsFor: 'accessing' stamp: 'tg 1/20/2010 10:50'!
defaultEnvironment
	^ GTSTModel defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/16/2009 15:11'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous ST Browser'.
	self layout.
	self onPackages.
	self onClassesFromPackages.
	self onInstVarsFromClasses.
	self onMethodsFromClasses.
	self onMethodsFromInstVars.
	self onDetailsFromPackagesFromClassesFromMethods.
	browser sendTo: #outer->#focusOnMethod from: #details->#focusOnMethod with: [:m | m ].
	browser sendTo: #packages->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior glmPackage].
	browser sendTo: #classes->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior ].
	browser sendTo: #methods->#selection from: #outer->#focusOnMethod with: [:method | method ]! !

!GTCodeBrowser methodsFor: 'opening' stamp: 'tg 1/20/2010 10:51'!
entity 
	^ GTSTPackage rootPackagesOn: self class defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 09:36'!
layout
	browser
		column: #packages;
		column: [:c | c row: #classes; row: #instVars ];
		column: [:c | c row: #methods; row: #details] span: 3.! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 11:49'!
onClassesFromPackages
	browser
		showOn: #classes; from: #packages;
		using: [browser tree
					when: [:package | package isCollection not];
					display: [:package | package allClasses];
					children: [ :each | each traits ];
					icon: [ :each | 
						each stBehavior theNonMetaClass browserIcon isNil ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ];
					format: [:class | class name]]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:41'!
onDetailsFromPackagesFromClassesFromMethods
	browser
		showOn: #details; from: #classes; from: #methods; from: #packages; 
		using: [
			browser text
					forSmalltalk: [:class | class stBehavior ];
					title: 'Method';
					display: [:class :method | method sourceCode ].
			browser text
					forSmalltalk;
					title: 'Class';
					useExplicitNotNil;
					when: [:class :method | class notNil and: [method isNil]];
					display: [:class | class definition ].
			browser list
					title: 'References';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class references];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Senders';
					display: [:class :method | method senders];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Implementors';
					display: [:class :method | method implementors];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
		]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onInstVarsFromClasses
	browser showOn: #instVars; from: #classes; using: [ 
		browser list
				display: [ :class | class instVars ];
				tags: [ :each | 
					{ each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST'] } ] ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 1/17/2010 04:45'!
onMethodsFromClasses
	browser transmit to: #methods; from: #classes; andShow: [ :a | 
		a accordionArrangement.
		a list
				title: 'Instance';
				display: [ :class | class methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		a list
				title: 'Meta';
				display: [ :class | class metaSide methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		 ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onMethodsFromInstVars
	browser showOn: #methods; from: #instVars; using: [ 
		browser list
				display: [ :var | var accessingMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 10/17/2009 17:08'!
onPackages
	browser
		showOn: #packages;
		using: 
			[ browser tree
				children: [ :package | package subPackages ];
				format: [ :package | package name ];
				filterOn: [ :text :each | text match: each name ] ]! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'building' stamp: 'tg 1/16/2010 23:07'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metacello Browser'.
	browser column: #configs; column: #versions; column: #packages span: 2.
	self toConfigsAndShow.
	self toVersionsFromConfigsAndShow.
	self toPackagesFromVersionsAndShow.
	^ browser ! !

!GTMetaceller methodsFor: 'opening' stamp: 'tg 1/17/2010 01:38'!
entity 
	^ (Object subclasses select: [:each | (each class canUnderstand: #isMetacelloConfig) and: [
			each isMetacelloConfig ] ]) sort: [:a :b | a name < b name]! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 1/21/2010 01:20'!
goferForVersion: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	version spec packages do: [:each | 
		(each isKindOf: MetacelloPackageSpec) ifTrue: [ g package: each name]].
	^ g! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 1/21/2010 01:01'!
packageSpec: packageSpec hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: packageSpec name.
	^ g resolved first name ~= packageSpec currentVersionInfo name! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 12/15/2009 13:58'!
packageSpecNeedsSaving: aPackageSpec
	| copy |
	copy := aPackageSpec workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 1/20/2010 00:54'!
packagesAndGroupsOf: version
	| packageMap |
	packageMap := Dictionary new.
	version groups do: [:eachGroup |
		(version packagesForSpecNamed: eachGroup name) do: [:eachPackage |
			packageMap at: eachPackage ifAbsentPut: [OrderedCollection new].
			(packageMap at: eachPackage) add: eachGroup name ] ].
	^ packageMap! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 1/21/2010 12:32'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 1/20/2010 00:54'!
tagsOf: packageSpec in: version
	^ (self packagesAndGroupsOf: version) at: packageSpec ifAbsent: [OrderedCollection new]! !

!GTMetaceller methodsFor: 'building' stamp: 'tg 1/28/2010 00:52'!
toConfigsAndShow
	browser transmit to: #configs; andShow: [ :a |
		| configList |
		a title: 'Configurations'.
		configList := a list
			format: [:configClass | | text label version |
				label := self shortNameOf: configClass.
				version := configClass project currentVersion.
				text := version notNil
					ifTrue: [ (label, ' [', version versionString, ']') ]
					ifFalse: [ Text string: label attribute: TextColor gray].
				text ];
			act: [:list  | list selection browse ] entitled: 'Browse implementation';
			act: [:list  | list selection project inspect] entitled: 'Inspect'.
			Smalltalk at: #OBCmdMetacello ifPresent: [ :x |
				configList actions: [:list | 
					(GTOBCommandAdaptor new 
						actionsFrom: (Smalltalk at: #OBCmdMetacello) subclasses 
						on: list selection 
						for: nil ) do: [:each | each category: 'OB Commands'] ] ] ]! !

!GTMetaceller methodsFor: 'building' stamp: 'tg 1/28/2010 00:49'!
toPackagesFromVersionsAndShow
	browser transmit to: #packages; from: #versions; andShow: [ :a |
		a title: [:version | version name ].
		a tree
			title: 'Items';
			display: [:version | version spec packages packageSpecsInLoadOrder];
			format: [:packageSpec | | text |
				text := ((packageSpec isKindOf: MetacelloPackageSpec) and: [
					self packageSpecNeedsSaving: packageSpec])
						ifTrue: [Text string: packageSpec name attribute: TextColor blue] 
						ifFalse: [ Text string: packageSpec name attribute: (packageSpec isLoaded ifTrue: [TextColor black] ifFalse: [TextColor gray])].
				(packageSpec isKindOf: MetacelloGroupSpec) ifTrue: [ text addAttribute: TextEmphasis italic from: 1 to: text size ].
				text] ;
			children: [:spec | 
				(spec isKindOf: MetacelloProjectReferenceSpec) 
					ifTrue: [ spec projectReference version spec packages packageSpecsInLoadOrder ]
					ifFalse: [	#() ]
				];
			tags: [:packageSpec :version | 
				self tagsOf: packageSpec in: version  ]; 
			act: [:list  | list selection inspect] entitled: 'Inspect';
			act: [:list :version | version load: list selection name ] entitled: 'Load'.
 		a mondrian
			title: 'Dependencies';
			painting: [:view :version | self viewDependenciesOf: version on: view].
		a text 
			title: 'Script';
			forSmalltalk;
			display: [:version |
				version spec printString ].
		a list
			title: 'Newer in repository?';
			display: [:version | version spec packages packageSpecsInLoadOrder ];
			format: [:packageSpec :version | ((packageSpec isKindOf: MetacelloPackageSpec) and: [
					self  packageSpec: packageSpec hasNewerVersionsFrom: version])
				ifTrue: [Text string: packageSpec name attribute: TextColor red] ifFalse: [packageSpec name]];
			act: [:list  | list selection inspect] entitled: 'Inspect'
	]! !

!GTMetaceller methodsFor: 'building' stamp: 'DaleHenrichs 1/21/2010 14:43'!
toVersionsFromConfigsAndShow.
	browser transmit to: #versions; from: #configs; andShow: [ :a |
		a title: [:config | self shortNameOf: config ].
		a list
			title: 'Versions';
			display: [:config | config project versions reverse ];
			format: [:each :config | | text |
				text := ([each isPossibleBaseline not] on: Error do: [true])
					ifTrue: [Text string: each versionNumber asString attribute: TextColor gray] 
					ifFalse: [each versionNumber asString asText].
				config project currentVersion = each ifTrue: [ text allBold ].
				text ];
			act: [:list | 
				(self goferForVersion: list selection) browseRemoteChanges ] entitled: 'Browse remote changes';
			act: [:list  | list selection inspect] entitled: 'Inspect'.
		a mondrian
			title: 'Imports';
			painting: [:view :config | self viewVersionMapOf: config on: view]]! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 12/15/2009 14:02'!
viewDependenciesOf: version on: view
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view shape curvedLine.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 12/19/2009 11:09'!
viewVersionMapOf: configClass on: view

	| prag1 prag2 nodes edges version imported |
	prag1 := Pragma allNamed: #version:imports: in: configClass.
	prag2 := Pragma allNamed: #version: in: configClass.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	prag2 do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)) ].
	prag1 do: [:prag | 
		version := nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [configClass project version: eachImportPrag].
			edges add: version -> imported.
			]
		].
	view shape label text: [:each | each versionNumber printString].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMGlobalBrowserTemplate subclass: #GTProfStef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTProfStef commentStamp: 'tg 2/1/2010 15:40' prior: 0!
self openOn: SmalltalkSyntaxTutorial.!

!GTProfStef classSide methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:38'!
openOn: tutorial
	^ super openOn: (ProfStef goOn: tutorial viewedWith: GTProfStefNoView new)! !

!GTProfStef methodsFor: 'building' stamp: 'tg 2/1/2010 15:52'!
buildBrowser
	browser := GLMFinder new.
	browser title: 'Prof Stef'.
	browser text
		forSmalltalk;
		display: [ :lesson | lesson lesson ];
		when: [:lesson | lesson isKindOf: Lesson];
		title: #title;
		update: #selection
			on: $o
			entitled: 'Open (o)'
			with: 
				[ :text :entity | 
				Compiler 
					evaluate: text selectedText
					for: entity
					logged: false ];
		act: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'.
	^ browser! !

!GTProfStef methodsFor: 'opening' stamp: 'tg 2/1/2010 15:42'!
entity
	^ ProfStef goOn: SmalltalkSyntaxTutorial viewedWith: GTProfStefNoView new! !

GLMBrowserTemplate subclass: #GTChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTChaser commentStamp: 'tg 12/29/2009 03:58' prior: 0!
self openOn: #buildBrowser!

!GTChaser methodsFor: 'building' stamp: 'tg 1/15/2010 03:40'!
buildBrowser
	"self openOn: #browser"
	browser := GLMFinder new.
	browser title: [:each | 'Chasing Browser of #', each].
	browser show: [:a |
		a custom: self methodSourceBrowser.
	].
	^ browser! !

!GTChaser methodsFor: 'building' stamp: 'tg 1/14/2010 23:00'!
methodSourceBrowser
	| browser |
	browser := GLMTabulator new.
	browser row: #methods; row: #source.
	browser transmit to: #methods; andShow: [ :a | 
		a tree
			title: 'Senders';
			display: [ :each | 
				self systemNavigation allSendersOf:	((each isKindOf: MethodReference) ifTrue: [each selector ] ifFalse: [ each ]) ];
			format: [:each | 
				(each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ]]";
			children: [ :each | 
				(each isKindOf: MethodReference) ifTrue: [each compiledMethod messages] ifFalse: [OrderedCollection new]]" ].
	browser transmit from: #methods; to: #source; andShow: [:a |
		a text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | reference sourceCode ];
			whenKindOf: MethodReference ].
	browser transmit from: #methods; to: #outer->#selection.
	^ browser! !

GLMBrowserTemplate subclass: #GTClassicChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTClassicChaser commentStamp: 'tg 1/15/2010 01:14' prior: 0!
self openOn: #browse!

!GTClassicChaser methodsFor: 'as yet unclassified' stamp: 'tg 1/15/2010 03:03'!
buildBrowser
	"self openOn: #buildBrowser"
	| finder |
	finder := GLMFinder new.
	finder show: [:a |
		a title: [:each | (each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ] ].
		a tree
			title: 'Implementors';
			display: [ :each | 
				self systemNavigation allImplementorsOf: ((each isKindOf: MethodReference) ifTrue: [each selector ] ifFalse: [ each ]) ];
			format: [:each | 
				(each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ]];
			children: [ :each | 
				(each isKindOf: MethodReference) ifTrue: [each compiledMethod messages] ifFalse: [OrderedCollection new]].
		a tree
			title: 'Senders';
			display: [ :each | 
				self systemNavigation allSendersOf:	((each isKindOf: MethodReference) ifTrue: [each selector ] ifFalse: [ each ]) ];
			format: [:each | 
				(each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ]];
			children: [ :each | 
				(each isKindOf: MethodReference) ifTrue: [each compiledMethod messages] ifFalse: [OrderedCollection new]]].
	browser := GLMTabulator new.
	browser title: [:each | 'Chasing Browser of ', each].
	browser row: #finder; row: #details.
	browser showOn: #finder; using: [browser custom: finder].
	browser showOn: #details; from: #finder; using: [
		browser text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | [reference sourceCode ] on: Error do: ['source not found'] ];
			whenKindOf: MethodReference ].
	^ browser! !

GLMBrowserTemplate subclass: #GTDiffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTDiffer commentStamp: 'tg 12/29/2009 16:46' prior: 0!
self openOn: Collection withAllSubclasses andOn: MooseGroup withAllSubclasses!

!GTDiffer classSide methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 16:34'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	^ self new openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses! !

!GTDiffer methodsFor: 'building' stamp: 'tg 1/20/2010 10:54'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous Diff Browser'.
	browser
		row: [:r | r column: #left; column: #right ];
		row: #diff.
	browser sendTo: #outer->#leftClasses from: #outer->#entity with: [:assoc | assoc key].
	browser sendTo: #outer->#rightClasses from: #outer->#entity with: [:assoc | assoc value].
	browser showOn: #left; from: #outer->#leftClasses; using: [browser custom: GTSimpleClassesBrowser new browser ].
	browser showOn: #right; from: #outer->#rightClasses; using: [browser custom: GTSimpleClassesBrowser new browser ].
	browser showOn: #diff; 
		from: #left->#selectedClass; from: #left->#selectedMethod;
		from: #right->#selectedClass; from: #right->#selectedMethod;
		using: [
		browser diff
			display: [:leftClass :leftMethod :rightClass :rightMethod | 
				Array with: (leftClass sourceCodeAt: leftMethod) with: (rightClass sourceCodeAt: rightMethod)
			]
		].
	^ browser! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:50'!
openOn: aCollectionOfClasses
	self browser openOn: aCollectionOfClasses andOn: aCollectionOfClasses! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:36'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	self browser openOn: aCollectionOfClasses -> anotherCollectionOfClasses! !

GLMBrowserTemplate subclass: #GTLintBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTLintBrowser commentStamp: 'tg 12/29/2009 03:55' prior: 0!
self openOn: GLMPresentation withAllSubclasses asOrderedCollection!

!GTLintBrowser methodsFor: 'building' stamp: 'tg 1/16/2010 22:35'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Lint Browser'.
	browser column: #groups; column: #rules; column: #results.
	browser transmit from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; to: #groups; andShow: [ :a |
 		a list
			display: [:dic | RBCompositeLintRule lintChecks rules];
			allowNil;
			format: #name ].
	browser showOn: #rules; from: #groups; using: [
		browser list
			display: [:group | group rules];
			format: #name ].
	browser transmit to: #results; from: #rules; from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; andShow: [ :a |
		a list
			display: [:rule :tuple | self getLintResult:
					(self runRule: rule forClasses: tuple) result] ].
			"tuple = {class. selector} from the browser. We select the class"
	browser sendToOutside: #faultyMethod from: #results->#selection.
	^ browser! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:22'!
getLintResult: anEnvironment

	| results stream |
	results := OrderedCollection new.
	anEnvironment classesAndSelectorsDo: [:class :sel | results add: sel].
	^ results! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:28'!
runRule: aRule forClasses: aClassesCollection

	| environment |
	environment := BrowserEnvironment new forClasses: aClassesCollection.
	^ SmalllintChecker runRule: aRule onEnvironment: environment! !

GLMBrowserTemplate subclass: #GTMessageTallyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTMessageTallyBrowser commentStamp: 'tg 12/29/2009 03:35' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'tg 12/29/2009 03:41'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Message Tally'.
	browser column: #messages; column: #details.
	browser showOn: #messages; using: [
		browser tree
			children: [:each | each sonsOver: -1 ];
			format: [:each | Text fromString: (each printString, ' (', each tally printString, ')')]].
	browser showOn: #details; from: #messages; using: [
		browser text
			forSmalltalk: [:each | each method methodClass];
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]].
	^ browser! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'tg 12/29/2009 03:36'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GTMessageTallyFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTMessageTallyFinder commentStamp: 'tg 12/29/2009 04:07' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:08'!
buildBrowser
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'Messages';
		display: [:each | each sonsOver: -1];
		format: [:each | each printString, ' (', each tally printString, ')'].
	browser := GLMTabulator new.
	browser row: #messages; row: #source.
	browser showOn: #messages; using: [browser custom: finder].
	browser showOn: #source; from: #messages; using: [
		browser text
			title: 'Source';
			forSmalltalk: [:each | each method methodClass];			
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:07'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GTObjectFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTObjectFinder commentStamp: 'tg 12/29/2009 03:43' prior: 0!
self openOn: Smalltalk!

!GTObjectFinder methodsFor: 'building' stamp: 'tg 12/29/2009 03:41'!
buildBrowser
	browser := GLMFinder new.
	browser list
		title: [ :anObject | self printObjectAsAnItem: anObject ];
		display: 
			[ :anObject | 
			anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
		format: [ :assoc | assoc key asString , ' : ' , (assoc value printString copyFrom: 1 to: ((50 min: assoc value printString size) max: 0)) ];
		send: #value.
	browser list
		title: 'Collection';
		when: [ :each | each isCollection ].
	browser text
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		update: #selection
			on: $o
			entitled: 'Open (o)'
			with: 
				[ :text :entity | 
				Compiler 
					evaluate: text selectedText
					for: entity
					logged: false ];
		act: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'.
	^ browser! !

!GTObjectFinder methodsFor: 'private' stamp: 'tg 12/29/2009 03:43'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

GLMBrowserTemplate subclass: #GTSimpleClassesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTSimpleClassesBrowser commentStamp: 'tg 12/29/2009 03:50' prior: 0!
self openOn: Collection withAllSubclasses!

!GTSimpleClassesBrowser methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 03:50'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #classes; column: #methods.
	browser showOn: #classes; using: [
		browser list
			display: [:classes | classes asOrderedCollection sortBy: [:a :b | a name < b name] ]].
	browser showOn: #methods; from: #classes; using: [
		browser list
			display: [:cls | cls selectors asOrderedCollection sortBy: [:a :b | a < b]]].
	browser sendToOutside: #selectedClass from: #classes.
	browser sendToOutside: #selectedMethod from: #methods.
	^ browser! !
